<?php

if(isset($_POST['users-csv'])) {
	// fork de core/admin/plugin.php
	include(realpath(__DIR__.'/../../core/admin/prepend.php'));
	$plugin = plxUtils::nullbyteRemove('users_csv');
	if(isset($plxAdmin->plxPlugins->aPlugins[$plugin])) {
		$plxPlugin = $plxAdmin->plxPlugins->aPlugins[$plugin];
		$plxAdmin->checkProfil($plxPlugin->getAdminProfil());
	}
}

if(! defined('PLX_ROOT')) { exit; }

if(isset($_FILES['users-csv-file'])) {

	$location = ($_POST['users-csv']) ? '../../core/admin/parametres_users.php' : 'plugin.php?p='.$plugin;

	// drop empty lines
	$lines = array_filter(
		file($_FILES['users-csv-file']['tmp_name']),
		function($item) { return ! empty(strlen(trim($item))); }
	);
	// get title of columns  in 1st line
	$cols = explode(',', strtolower(array_shift($lines)));
	$fields = array();
	for($i=0; $i < count($cols); $i++) {
		$fields[$cols[$i]] = $i;
	}
	// check if column for login exists
	if(array_key_exists('login', $fields)) {
		// get the list of logins already presents
		$used_logins = array();
		foreach($plxAdmin->aUsers as $id_user=>$infos) {
			$used_logins[$infos['login']] = $id_user;
		}
		$bad_logins = array();
		// init datas for plxAdmin::editUsers()
		$datas = array(
			'update' => true,
			'userNum' => array()
		);
		# get the top of id users
		$a = array_keys($plxAdmin->aUsers);
		if($plxAdmin->aUsers) {
			rsort($a);
		} else {
			$a['0'] = 0;
		}
		$userId = $a[0] + 1;
		$langs = plxUtils::getLangs();
		// fields used by PluXml. Notice: login is required
		$plxFields = explode(',', 'login,name,active,profil,password,lang,email,infos');
		// some values for active or deleted users
		$actifs = array('1', 'y', 'o', 't', 'true', 'vrai', 'oui');
		// loop for every line of the input file
		$countUsers = 0;
		foreach($lines as $line) {
			$update = false;
			$cells = explode(',', $line);
			// First, get the login
			$col0 = $fields['login'];
			if(! empty(trim($cells[$col0]))) {
				if(array_key_exists(trim($cells[$col0]), $used_logins)) {
					$bad_logins[] = $cells[$col0];
					$id = str_pad($used_logins[$cells[$col0]], 3, '0', STR_PAD_LEFT);
					$update = true;
				} else {
	 				$id = str_pad($userId, 3, '0', STR_PAD_LEFT);
				}
				$datas['userNum'][] = $id; // requested by plxAdmin::editUsers()
				// loop for each cell of the line
				foreach($plxFields as $fld) {
					if(array_key_exists($fld, $fields)) {
						$key = $id.'_'.$fld;
						$value = filter_var(trim($cells[$fields[$fld]]), FILTER_SANITIZE_STRING);
						if(! empty($value)) { $datas[$key] = $value; }
					}
				}

				// post-checking
				if(! $update) {
					if(empty($datas[$id.'_name'])) { $datas[$id.'_name'] = $datas[$id.'_login']; }
					if(empty($datas[$id.'_password'])) { $datas[$id.'_password'] = DEFAULT_PASSWORD; }
				} else {
					if(! isset($datas[$id.'_password'])) { $datas[$id.'_password'] = ''; } // required by plxAdmin::editUsers()
				}
				$datas[$id.'_active'] = (! empty($datas[$id.'_active']) && in_array(strtolower($datas[$id.'_active']), $actifs)) ? 1 : 0;
				$datas[$id.'_delete'] = (! empty($datas[$id.'_delete']) && in_array(strtolower($datas[$id.'_active']), $actifs)) ? 1 : 0;
				if(! empty($datas[$id.'_profil'])) {
					$level = intval($datas[$id.'_profil']);
					if(($level < PROFIL_ADMIN) or ($level > PROFIL_WRITER)) {
						$level = PROFIL_WRITER;
					}
					$datas[$id.'_profil'] = ($level == PROFIL_ADMIN) ? PROFIL_MANAGER : $level;
				} elseif(! $update) {
					$datas[$id.'_profil'] = PROFIL_WRITER;
				}
				if(! empty($datas[$id.'_lang'])) {
					$lang = strtolower(substr($datas[$id.'_lang'], 0, 2));
					if(in_array($lang, $langs)) {
						$datas[$id.'_lang'] = $lang;
					} else {
						unset($datas[$id.'_lang']);
					}
				}
				if(! empty($datas[$id.'_email']) and! filter_var($datas[$id.'_email'], FILTER_VALIDATE_EMAIL)) {
					unset($datas[$id.'_email']);
				}

				$countUsers++;

				// next user, please
				$userId++;
			}
		}
		// Save $datas in PluXml
		if($plxAdmin->editUsers($datas)) {
			$_SESSION[$plugin] = str_replace('##COUNT##', $countUsers, $plxPlugin->getLang('MESSAGE'));
		}
	} else {
		$_SESSION[$plugin] = $plxPlugin->getLang('LOGIN_REQUIRED');
	}
	header('Location: '.$location);
	exit;
}

$plxPlugin->printForm(true);
?>